#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>

/* Quell- und Zieldatei */
FILE *fp1=NULL, *fp2=NULL;

/* Pointer auf Pufferbereich */
char *buf=NULL;

/* Routine zum "Aufrumen" */
void aus(void)
{
  if (fp1)
    fclose(fp1);

  if (fp2)
    fclose(fp2);

  if (buf)
    free(buf);

  exit(0);
}

int main(int argc, char **argv)
{
 /* String fr "system" */
 char del[100];
 /* Puffergre (Default = 32 KB) */
 unsigned long buffsize = 32768, fsize;
 /* Gelesene und geschriebene Bytes, Laufvariable */
 int size, size1, i;
 /* stat wird bentigt, um Dateigre zu ermitteln */
 struct stat stdbuf;

 /* Anzahl der Parameter gut ? */
 if (argc < 3) {
   printf("Benutzung : %s <sourcefile> "
          "<destinationfile> [Puffergre"
          " in KB]\n", argv[0]);
   exit(0);
 }

 /* Dateien ffnen */
 if (!(fp1 = fopen(argv[1], "r"))) {
   printf("File %s konnte nicht geffnet"
          " werden !\n", argv[1]);
   aus();
 }

 if (!(fp2 = fopen(argv[2], "w"))) {
   printf("File %s konnte nicht geffnet"
          " werden !\n", argv[2]);
   aus();
 }

 /* Wenn angegeben, Puffergre neu belegen */
 if (argc == 4)
   buffsize = strtol(argv[3], NULL, 10) * 1024;

 if (!(buf = malloc(buffsize))) {
    printf("Puffergre %s KB zu gro ! \n", argv[3]);
    aus();
 }

 /* Dateigre bestimmen */
 stat(argv[1], &stdbuf);
 fsize = stdbuf.st_size;

 /* Solange nicht alles gelesen wurde */
 for (i = 0; i * buffsize < fsize; i++) {
   /* lesen */
   size = fread(buf, 1, buffsize, fp1);

   /* schreiben */
   size1 = fwrite(buf, 1, size, fp2);

   /* Erfolgskontrolle nach dem Schreiben */
   if (size1 != size) {
       /* Bei Fehler : Meldung, Dateien schlieen */
       /* und Zieldatei lschen */
       printf("\nSchreibfehler !\n");
       fclose(fp1);
       fclose(fp2);
       strcpy(del, "delete ");
       strcat(del, argv[2]);
       system(del);
       exit(0);
   }

   /* Statistik ausgeben */
   printf("%d Prozent\r", (int) ((double) (i + 1)
                       * buffsize / fsize * 100));
   fflush(stdout);
 }

 aus();
}
